import type { Arg, CacheEntries, CacheEventType, CacheEventListener, CacheNode, EventEmitter, Key, Options } from './internalTypes';
export declare class Cache<Fn extends (...args: any[]) => any> {
    size: number;
    a: (a: Arg, b: Arg) => boolean;
    h: CacheNode<Fn> | null;
    k: ((args: IArguments | Key) => Key) | undefined;
    l: number;
    m: (a: Key, b: Key) => boolean;
    oa: EventEmitter<'add', Fn> | null;
    od: EventEmitter<'delete', Fn> | null;
    oh: EventEmitter<'hit', Fn> | null;
    ou: EventEmitter<'update', Fn> | null;
    p: boolean;
    t: CacheNode<Fn> | null;
    constructor(options: Options<Fn>);
    clear(): void;
    delete(key: Parameters<Fn>): boolean;
    entries(): CacheEntries<Fn>;
    get(key: Parameters<Fn>): ReturnType<Fn> | undefined;
    has(key: Parameters<Fn>): boolean;
    off<Type extends CacheEventType>(type: Type, listener: CacheEventListener<Type, Fn>): void;
    on<Type extends CacheEventType, Listener extends CacheEventListener<Type, Fn>>(type: Type, listener: Listener): Listener;
    set(key: Parameters<Fn>, value: ReturnType<Fn>): CacheNode<Fn>;
    c<Type extends CacheEventType>(type: Type): EventEmitter<Type, Fn>;
    d(node: CacheNode<Fn>): void;
    e(prevKey: Key, nextKey: Key): boolean;
    g(key: Key): CacheNode<Fn> | undefined;
    gt(key: Parameters<Fn>): CacheNode<Fn> | undefined;
    n(key: Key, value: ReturnType<Fn>): CacheNode<Fn>;
    og(type: CacheEventType): EventEmitter<CacheEventType, Fn> | null;
    os(type: CacheEventType, emitter: EventEmitter<CacheEventType, Fn> | null): void;
    u(node: CacheNode<Fn>): void;
}
