import type { CacheEntry, CacheNode, Key, Memoized } from './internalTypes';
type TypeOf = 'bigint' | 'boolean' | 'function' | 'number' | 'object' | 'string' | 'symbol' | 'undefined';
export declare function cloneKey<Fn extends (...args: any[]) => any>(args: IArguments | Parameters<Fn> | Key): [...Parameters<Fn>];
export declare function getDefault<Value>(type: TypeOf, value: Value, defaultValue?: undefined): Value | undefined;
export declare function getDefault<Value, DefaultValue>(type: TypeOf, value: Value, defaultValue: DefaultValue): Value extends undefined ? DefaultValue : Value;
export declare function getEntry<Fn extends (...args: any[]) => any>(node: CacheNode<Fn>): CacheEntry<Fn>;
export declare function isMemoized(fn: any): fn is Memoized<any, any>;
export declare function isSameValueZero(a: any, b: any): boolean;
export {};
